<template lang="pug">
  .search
    .search-icon(v-on:click="$emit('select-search')")
      .icon(v-html="$icons.search")
    input(
      v-bind:value="searchQuery"
      v-on:input="input"
      v-on:focus="focus($event)"
      v-on:click="focus($event)"
      v-on:keydown.enter="search()"
      v-on:keydown.up.prevent="selectSuggestion(SELECT_SUGGESTION_UP)"
      v-on:keydown.down.prevent="selectSuggestion(SELECT_SUGGESTION_DOWN)"
      placeholder="Search..."
      tabindex="0"
      ref="searchInput"
    )
    .close-button(
      v-if="isMobile"
      v-html="$icons.close"
      @click="$emit('close')"
    )
    .button-clear(
      v-if="searchQuery && !isMobile"
      v-on:click="clear()"
    )
      .icon(
        v-html="$icons.close"
      )
    .suggestions(
      v-if="showSuggestions"
      ref="suggestions"
    )
      .loader(v-if="suggestionsLoading")
      .not-found(v-if="!suggestionsLoading && !suggestions.length")
        span We have nothing similar to&nbsp;
        strong {{ searchQuery }}
        span . Try different word.
      .suggestion(
        v-if="suggestions.length"
        v-for="(suggestion, index) in suggestions"
        v-on:click="search(suggestion.name)"
        v-bind:class="{ 'border-bottom': index !== suggestions.length - 1, active: suggestion.active }"
      )
        div(v-html="suggestion.title")
</template>

<script>
import { mapState } from 'vuex'
import itemsService from '../../services/items/common'
import debounce from 'debounce'
import photosApi from '../../api/photos'

const SELECT_SUGGESTION_UP = 'up'
const SELECT_SUGGESTION_DOWN = 'down'

export default {
  name: 'Search',
  data () {
    return {
      suggestions: [],
      currentSuggestionIndex: null,
      suggestionsLoading: false,
      showSuggestions: false,
      SELECT_SUGGESTION_UP,
      SELECT_SUGGESTION_DOWN
    }
  },
  computed: {
    ...mapState({
      searchQuery: state => state.editor.searchQuery,
      isMobile: state => state.editor.isMobile,
      searchQueryClean: state => (state.editor.searchQuery || '').replace(/[^'0-9A-Za-za-zа-яА-Я-\s]/g, '')
    })
  },
  watch: {
    searchQuery () {
      if (!this.searchQuery) {
        this.clear()
      }
    },
    showSuggestions () {
      if (!this.showSuggestions) {
        this.$emit('suggest-stop')
        this.currentSuggestionIndex = null
      }
    }
  },
  created: function () {
    this.debouncedSuggestions = debounce(this.suggest, 400)
  },
  mounted () {
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    search (query) {
      if (!this.searchQuery) {
        return
      }

      this.showSuggestions = false
      this.$emit('start')

      if (query) {
        this.$store.dispatch('searchQuerySet', query.replace(/[^'0-9A-Za-zа-яА-Я-\s]/gu, '').trim())
      }

      itemsService
        .search({ query: this.searchQueryClean.trim() })
        .then(response => this.$emit('stop'))
        .catch(error => {
          console.log(error)
          this.$emit('stop')
        })
    },
    suggest () {
      if (this.searchQueryClean) {
        photosApi.searchSuggest(this.searchQueryClean.trim())
          .then(suggestions => {
            this.suggestions = []
            suggestions.slice(0, 10).forEach(suggestion => {
              const regex = new RegExp(this.searchQueryClean, this.searchQueryClean.length > 1 ? 'g' : '')
              this.suggestions.push({
                title: suggestion.name.replace(regex, `<strong>${this.searchQueryClean}</strong>`),
                name: suggestion.name,
                active: false
              })
            })

            this.suggestionsLoading = false
          })
      }
    },
    selectSuggestion (direction) {
      if (this.suggestions.length) {
        if (direction === this.SELECT_SUGGESTION_UP) {
          if (this.currentSuggestionIndex === null) {
            this.currentSuggestionIndex = this.suggestions.length - 1
          } else {
            this.suggestions[this.currentSuggestionIndex].active = false
            this.currentSuggestionIndex -= 1
            if (this.currentSuggestionIndex < 0) {
              this.currentSuggestionIndex = this.suggestions.length - 1
            }
          }
        } else if (direction === this.SELECT_SUGGESTION_DOWN) {
          if (this.currentSuggestionIndex === null) {
            this.currentSuggestionIndex = 0
          } else {
            this.suggestions[this.currentSuggestionIndex].active = false
            this.currentSuggestionIndex += 1
            if (this.currentSuggestionIndex > this.suggestions.length - 1) {
              this.currentSuggestionIndex = 0
            }
          }
        }

        this.suggestions[this.currentSuggestionIndex].active = true
        this.$store.dispatch('searchQuerySet', this.suggestions[this.currentSuggestionIndex].name)
        this.$nextTick(() => this.$refs.searchInput.select())
      }
    },
    input (event) {
      this.$store.dispatch('searchQuerySet', event.target.value)
      this.startSuggesting()
    },
    startSuggesting () {
      this.suggestions = []
      this.debouncedSuggestions()
      this.showSuggestions = true
      this.suggestionsLoading = true
      this.$emit('suggest-start')
    },
    focus (event) {
      event.target.select()
      if (this.searchQuery) {
        this.startSuggesting()
      }
    },
    clear () {
      this.$store.dispatch('searchQuerySet', null)
      this.$store.dispatch('setSearchModels', { items: [], total: 0, page: 1 })
      this.$store.dispatch('setSearchObjects', { items: [], total: 0, page: 1 })
      this.$store.dispatch('setSearchBackgrounds', { items: [], total: 0, page: 1 })
      this.suggestions = []
      this.showSuggestions = false
      this.$refs.searchInput.focus()
      this.$emit('clear')
    },
    handleEnter () {
      this.search()
    },
    outsideClick (event) {
      if (!this.$refs.searchInput.contains(event.target)) {
        this.$refs.searchInput.selectionEnd = this.$refs.searchInput.selectionStart
      }
      if (this.$refs.suggestions && !this.$refs.suggestions.contains(event.target)) {
        this.showSuggestions = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../assets/css/mixins';
  @import '../../assets/css/variables';

  .search {
    display: flex;
    flex-direction: row;
    align-items: center;
    height: 56px;
    position: relative;
    border-bottom: 1px solid rgba(255, 255, 255, 0.05);
    margin-left: -8px;
    z-index: 10;

    .search-icon {
      position: absolute;
      left: 0;
      top: 0;
      bottom: 0;
      display: flex;
      align-items: center;
      justify-content: center;
      width: 56px;
      height: 56px;
      cursor: pointer;

      .icon {
        fill: #5f5f5f;
        width: 16px;
        height: 16px;
      }
    }

    .icon-container {
      width: 54px;
      height: 100%;
      display: flex;
      align-items: center;
      justify-content: center;
      margin-right: 16px;

      .icon {
        fill: #5f5f5f;
        width: 16px;
        height: 16px;
      }
    }

    input {
      height: 100%;
      background-color: transparent;
      width: calc(100% - 56px);
      padding-left: 56px;
      border: none;
      outline: 0;
      color: #fff;
      font-size: 14px;

      &::selection {
        background-color: #84acc2;
        color: #fff;
      }

      &::-moz-selection {
        background-color: #84acc2;
        color: #fff;
      }
    }

    .button-clear {
      width: 56px;
      height: 56px;
      display: flex;
      align-items: center;
      justify-content: center;
      cursor: pointer;

      .icon {
        width: 12px;
        height: 12px;
      }
    }

    &:hover, &:focus, &:focus-within {
      .icon {
        fill: #fff;
        @include delay();
      }
    }

    .suggestions {
      width: calc(100% - 8px);
      position: absolute;
      top: 64px;
      padding: 8px 0;
      background-color: #fff;
      border-radius: 6px;
      color: #000;

      .suggestion {
        display: flex;
        flex-direction: row;
        padding: 8px 16px;

        &.border-bottom {
          border-bottom: 1px solid rgba(26, 26, 26, 0.05);
        }

        &.active, &:hover {
          background-color: rgba(26, 26, 26, 0.05);
          cursor: pointer;
        }
      }
    }

    .loader {
      width: 24px;
      height: 24px;
      margin: 8px auto;
      position: relative;
      @include loading(#1a1a1a, 3px, 24px);
    }

    .not-found {
      padding: 16px 48px;
      text-align: center;
    }
  }

</style>
